//Nedelcho Bozev 6gr fn:44547 Variant 2
//Zad 1
#include<iostream>
#include<string.h>
using namespace std;
template<class T>
class Sequence
{
public:
	Sequence(int =0);
	~Sequence();
	Sequence(const Sequence&);
	Sequence& operator=(const Sequence&);
	Sequence operator^(const Sequence&);
	Sequence operator()(int,int);
	Sequence<T>replace(T& item,Sequence<T>&replacement);
private:
	T *arr;
	int n;
};
template<class T>
Sequence<T>::Sequence(int k)
{
	arr=new T[k];
	for(int i=0;i<k;i++)
		arr[i]=0;
	n=k;
}
template<class T>
Sequence<T>::~Sequence()
{
	delete[]arr;
}
template<class T>
Sequence<T>::Sequence(const Sequence& a)
{
    this->arr=new T[a.n];
	for(int i=0;i<n;i++)
		this->arr[i]=a.arr[i];
	this->n=a.n;
}
template<class T>
Sequence& Sequence<T>::operator =(const Sequence &a)
{
	if(this!=&a){
		delete[]this->arr;
		this->arr=new T[a.n];
		for(int i=0;i<n;i++)
		this->arr[i]=a.arr[i];
		this->n=a.n;
	}
	return *this;
}
template<class T>
Sequence Sequence<T>::operator ^(const Sequence& a)
{
	int k=0
	if(this->n<a.n){
		Sequence b(this->n);
		b.arr=new T[this->n];
		for(int i=0;i<n;i++){
			if(this->arr[i]==a.arr[i]){
				b.arr[k]=this->arr[i];
				k++;
			}
		}
		return b;
	}
	else{
		Sequence b(a.n);
		b.arr=new T[a.n];
		for(int i=0;i<n;i++){
			if(a.arr[i]==this->arr[i]){
				b.arr[k]=a.arr[i];
				k++;
			}
		}
		return b;
	}
}


template<class T>
Sequence Sequence<T>::operator ()(int a,int b)
{
	if(a<b){
		Sequence a(b-a+1);
		for(int i=a;i<=b;i++)
			a.arr[i]=this->arr[i];
		return a;
	}
	if(a>b){
		Sequence a(a-b+1);
		for(int i=b;i<=a;i++)
			a.arr[i]=this->arr[i];
		return a;
	}
	else if(a==b){
		Sequence a(1);
	a.arr[0]=this->arr[a];
	return a;
	}
}





//Nedelcho Bozev 6gr fn:44547 variant 2
// Zad 2
#include<iostream>
#include<string.h>
using namespace std;
class EatingCreature
{
protected:
	double weight;
	double dkm;
	char*name;
public:
	EatingCreature(char* ="",double=0,double=0);
	~EatingCreature();
	EatingCreature(const EatingCreature&);
	EatingCreature& operator=(const EatingCreature&);
	virtual double RazhodEnerDen()=0;
	virtual double HranaNaden()=0;
	virtual double Razst_s_daeno_kol_hrana()=0;
	virtual void print()=0;
};
EatingCreature::EatingCreature(char *s , double w, double km)
{
	name=new char[strlen(s)+1];
	strcpy(name,s);
	weight=w;
	dkm=km;
}

EatingCreature::~EatingCreature()
{
	delete[]name;
}
EatingCreature::EatingCreature(const EatingCreature & a)
{
	this->weight=a.weight;
	this->dkm=a.dkm;
	this->name=new char[strlen(a.name)+1];
	strcpy(name,a.name);
}
EatingCreature& EatingCreature::operator =(const EatingCreature &a)
{
	if(this!=&a){
		delete[]this->name;
		this->name=new char[strlen(a.name)+1];
	    strcpy(name,a.name);
		this->weight=a.weight;
	    this->dkm=a.dkm;
return *this;
}
return *this;
}







class Dog:public EatingCreature
{
public:
	Dog(char* ="",double=0,double=0);
	virtual  double RazhodEnerDen();
	virtual double HranaNaden();
	virtual double Razst_s_daeno_kol_hrana();
    virtual void print();
};
Dog::Dog(char* s,double w,double km):EatingCreature(s,w,km){}
 double Dog::RazhodEnerDen()
{
	double E;
	E=weight*dkm;
	return E;
}
 double Dog::HranaNaden()
	{
		double H;
		H=2*Dog::RazhodEnerDen();
	return H;
	}
 double Razst_s_daeno_kol_hrana()
{
	double raz;
	raz=HranaNaden()/2*weight;
	return rez;
 }

 void print(){
	 cout<<"ku4eto teji:"<<weight<<endl;
	 cout<<"na den minava:"<<dkm<<endl;
	 cout<<"energiq na den:"<<RazhodEnerDen()<<endl;
	 cout<<"hrana na den:"<<HranaNaden()<<endl;
 }






 class American:public EatingCreature
 {
 private:
	 int brMC;
 public:
	 American(int,char* ="",double =0,double =0);
	 virtual  double RazhodEnerDen();
	virtual double HranaNaden();
	virtual double Razst_s_daeno_kol_hrana();
    virtual void print();
 };

 American::American(int a, char *s, double w, double km):EatingCreature(s,w,km)
 {
	 brMC=a;
 }

 
 double American::RazhodEnerDen()
 {
	 double rez;
	 rez=weight*dkm*0.1;
	 return rez;
 }



 double American::HranaNaden()
 {
	 double H;
	 H=RazhodEnerDen()+(0.2*RazhodEnerDen())*brMC;
	 return H;
 }

 double American::Razst_s_daeno_kol_hrana()
 {
	 
	double raz;
	raz=HranaNaden()/2*weight;
	return rez;
 }

 void print()
 {
	 cout<<"amerikaneca teji"<<weight<<endl;
	 cout<<"izrazhodva energiq na den:"<<RazhodEnerDen()<endl;
	 cout<<"na den qde:"<<HranaNaden()<<endl;
 }








 class Woman:public EatingCreature
 {
 private:
	 int age;
	 int nerv;
 public:
	 Woman(int,int,char* ="",double=0,double=0);
	  virtual  double RazhodEnerDen();
	virtual double HranaNaden();
	virtual double Razst_s_daeno_kol_hrana();
    virtual void print();
 };
 Woman::Woman(int a,int n, char *s, double w, double km):EatingCreature(s,w,km)
 {
	 age=a;
	 if(n>=1&&n<=3)
	 nerv=n;
	 else {
		 cout<<"ot 1 do 3 trqbva da e nervnostta.6te q s4itam za 1";
	   nerv=1;
	 }

 }
 double Woman::RazhodEnerDen()
 {
	 double raz;
	 raz=dkm*weigh;
	 return raz;
 }
 double Woman::HranaNaden()
 {
	 double H;
	 if(age>=12&&age<=42)
		 H=RazhodEnerDen()/2;
	 return H;
	 if(age>42)
		 H=RazhodEnerDen()+0.15*RazhodEnerDen();
	 return H;
 }
 double Woman::Razst_s_daeno_kol_hrana()
 {
	 return HranaNaden()/2*weight;
 }


    







