#include<iostream>
using namespace std;
template <class T>
class Bag
{
private:
	T*a;
	int n;
	static const int capacity =100;
public:
	Bag();
	~Bag();
	Bag(const T*,int);
	Bag(Bag const &);
	Bag& operator=(Bag const &);
	T* getElement(){ return a;}
	int getCount(){ return n;}
	bool operator-=(const T*);
	Bag operator |(const Bag &);
	Bag operator /(const Bag &);
};

template<class T>
class Set: public Bag<T>
{
private:
	T*b;
	int m;
	static const int capacity =101;
public:
	Set();
	~Set();
	Set(const T*,int);
	Set(Set const &);
	Set& operator=(Set const &);
	T* getElement(){return b;}
	int getCount(){return m;} 
	bool operator-=(const T*);
	Set operator |(const Set &);
	Set operator /(const Set &);
};

//Set triabva da naslediava Bag, zashto dublira vsichkite mu danni???

template<class T>
Bag<T>::Bag()
{
	a = new T[capacity];
	n = 0;
}

template<class T>
Bag<T>::Bag(const T *t, int c)
{
	n = c;
	a = new T[capacity];
	if(n<capacity){
	for(int i=0;i<n;i++)
		a[i]=t[i];
	}

	//a ako n >= capacity? tozi sluchai ili triabva da se dopuska za nevuzmojen, ili da se obrabotva (napr. da se kopirat samo capacity na broi elementi)
}

template<class T>
Bag<T>::Bag(const Bag<T> &b)
{
	n=b.n;
	a = new T[b.capacity]; //capacity e static, niama smisul da se vzima ot b, tia vinagi e 100
	for(int i=0;i<n;i++)
		a[i] =b.a[i];
	
}

template<class T>
Bag<T>:: ~Bag()
{
	delete[]a;
}

template<class T>
Bag<T>& Bag<T>::operator =(Bag<T> const &b)
{
	if(this!=&b)
	{
	n=b.n;
	a = new T[b.capacity];
	for(int i=0;i<n;i++)
		a[i] =b.a[i];
	}return *this;
}
template<class T>
bool Bag<T>::operator -=(const T *t) //tozi metod triabva da premahva element, obiasnihme go che ima greshka v uslovieto
{
	if(n<capacity)
	{
		a[n]=t;
		n++;
		return 0;
	}else return false;
}

template<class T>
Bag<T> Bag<T>::operator |(const Bag<T> &b)
{
	int size = capacity + b.capacity; //capacity e static, burkash capacity i n
	c = new T[size];
	int i;
	for(i=0;i<n;i++)c[i] = a[i];
	for(;i<n+b.n;i++)if(c[i]!=b.a[i])c[i] = b.a[i]; //c[i] ne e zadadeno, kak go sravniavash s b.a[i] ?
	return c;
}


template<class T>
Set<T>::Set()
{
	b = new T[capacity];
	m = 0;
}

template<class T>
Set<T>::Set(const T *t, int c):Bag<T>(t,c)
{
	m = c;
	b = new T[capacity];
	if(m<capacity){
	for(int i=0;i<m;i++)
		b[i]=t[i];
	}
}

template<class T>
Set<T>::Set(const Set<T> &s):Bag<T>(s)
{
	m=s.m;
	b = new T[s.capacity];
	for(int i=0;i<n;i++)
		b[i] =s.b[i];
	
}

template<class T>
Set<T>:: ~Set()
{
	delete[]b;
}

template<class T>
Set<T>& Set<T>::operator =(Set<T> const &s)
{
	if(this!=&b)
	{
	Bag<T>::operator =(s);
	n=b.n;
	b = new T[s.capacity];
	for(int i=0;i<n;i++)
		a[i] =b.a[i];
	}
}

template<class T>
bool Set<T>::operator -=(const T *t)
{
	if(m<capacity)
	{
		b[m]=t;
		m++;
		return 0;
	}else return false;
}

template<class T>
Set<T> Set<T>::operator |(const Set<T> &s)
{
	Bag<T>::operator -=(s); //zashto? tova izobshto ne raboti zaradi razlichni tipove, kakto shteshe da vidish, ako beshe testval da suzdadesh edin Set
	int size = capacity + s.capacity;
	c = new T[size];
	int i;
	for(i=0;i<m;i++)c[i] = b[i];
	for(;i<m+b.m;i++)if(c[i]!=s.b[i])c[i] = s.b[i];
	return c;
}

int main()
{
	int mas[] = {1,2,3};
	Bag<int> a(mas,4);
	//niama test na Set nito na funkciite na Bag
	return 0;
}

//Set triabva da naslediava Bag i samo da slaga ogranichenie za povtorenie na elementite!
