#include<iostream>
using namespace std;
template <class T>
class Bag
{
 public:
	int length;
	int capacity;
	 T* mas;
	 void resize(int newl)
 {T* m=new T[newl];
  capacity=newl;
  for (int i=0;i<length;i++)
  m[i]=mas[i];
  delete [] mas;
  mas=new T[newl]; //dostatuchno e da kajesh mas = m;
  for (int i=0;i<length;i++)
  mas[i]=m[i];
  delete [] m;
 }
	 Bag();
	 Bag(T* m,int len);
	 Bag(const Bag<T>& b);
	 void operator =(const Bag<T>& b);
	 ~Bag();
	 int count()
	 {return length;
	 }
	 bool is_Member(T d)
	 {for (int i=0;i<length;i++)
	  if (mas[i]==d)
		  return true;
	  return false;
	 }
	 bool operator +=(T d);
	 virtual Bag<T>& operator ^(Bag<T>& b);
	 void print();
};
template <class T>
Bag<T>::Bag()
{capacity=0;
 length=0;
}
template <class T>
Bag<T>::Bag(T* m,int len)
{mas=new T[len+5];
 length=len;
 capacity=len+5;
 for (int i=0;i<length;i++)
	 mas[i]=m[i];
}
template <class T>
Bag<T>::Bag(const Bag<T>& b)
{
 mas=new T[b.capacity];
 length=b.length;
 capacity=b.capacity;
 for (int i=0;i<length;i++)
	 mas[i]=b.mas[i];
}
template <class T>
void Bag<T>::print()
{for (int i=0;i<length;i++)
 cout<<" "<<mas[i];
}
template <class T>
void Bag<T>::operator =(const Bag<T>& b)
{if (this!=&b)
 {delete [] mas;
  mas=new T[b.length+5]; //operator = triabva da suzdava idelno kopie; 
 length=b.length;
 capacity=b.length+5; // => triabva capacity = b.capacity, zashtoto capacity = length + 5 ne vinagi e viarno
 for (int i=0;i<length;i++)
	 mas[i]=b.mas[i];
 }
}
template <class T>
Bag<T>::~Bag()
{delete [] mas;
}
template <class T>
bool Bag<T>::operator +=(T d)
{
 if (capacity==0)
 {mas=new T[5];
  capacity=5;
  length=0;
 }
 if (length==capacity) 
 resize(capacity+5);
 capacity=capacity+5; //tova sushto triabva da e v if-a, v protiven sluchai uvelichavash capacity po-burzo, otkolkoto zadeliash masiv
 mas[length]=d;
 length++;
 return false;
}
template <class T>
Bag<T>& Bag<T>::operator ^(Bag<T>& b)
{Bag<T>* nb=new Bag(); //silno nepreporuchitelno e da suzdavash obekti s new i prosto da gi vrushtash
 for (int i=0;i<length;i++) //ako pusnesh tvoiata programa, tia gurmi, zashtoto si izvikal tozi metod i nikoi ne e kazal delete na poluchenia obekt
 {
	 if (b.is_Member(mas[i]))
	 {
		 T d=mas[i];
		 nb->operator +=(d); //(*nb) += d;
	 }
 }
 return *nb;
}
template <class T>
class Set:public Bag<T>
{private:
 void resize(int newl)
 {Bag::resize() //zashto izobshto ia ima tazi implementacia? tova stava po podrazbirane
 }
 public:
	 Set();
	 Set(T* mas,int length);
	 Set(const Set<T>& b);
	 void operator =(const Set<T>& b);
	 ~Set();
	 int count() //tova sushto stava po podrazbirane, nali metodite se naslediavat, kakuv e smisulut da gi pishem pak?
	 {return length;
	 }
	 bool is_Member(T d) //i tuk
	 {return Bag::is_Member(d);
	 }
	 bool operator +=(T d);
	 Set<T>& operator ^(Set<T>& b);
	 void print();
};
template <class T>
Set<T>::Set()
{capacity=0;
 length=0;
}
template <class T>
Set<T>::Set(T* m,int len):Bag(m,len)
{
}
template <class T>
Set<T>::Set(const Set<T>& b):Bag(b)
{
}
template <class T>
void Set<T>::print() //i tuk
{Bag::print();
}
template <class T>
void Set<T>::operator =(const Set<T>& b)  
{Bag::operator =(b);
}
template <class T>
Set<T>::~Set()
{}
template <class T>
bool Set<T>::operator +=(T d)
{if (length==capacity)
 Bag::resize(capacity+5);
 if (!this->is_Member(d))
	 Bag::operator +=(d);
 return true;
}
template <class T>
Set<T>& Set<T>::operator ^(Set<T>& b)
{
 Set<T>* nb=new Set();
 for (int i=0;i<length;i++)
 {
	 if (b.is_Member(mas[i]))
	 {
		 T d=mas[i];
		 nb->operator +=(d);
	 }
 }
 return *nb;
}
int main()
{int mas[]={1,2,3,4,5};
int m[]={4,5,6,7,8};
 Bag<int> b(mas,5);
 b.print();
 cout<<endl;
 Bag<int> b1(m,5);
 b1.print();

 Bag<int> a(b^b1);
 cout<<endl;
 a.print();
 cout<<endl;
 Set<int> c(mas,5);
 c.print();
 cout<<endl;
 Set<int> c1(m,5);
 c1.print();
}