// Zad 2


#include <iostream>
#include <fstream>
#include <string>

#define PI  3.14

using namespace std;

class Shape
{
public:
	virtual void Create(void) = 0;
	virtual float Area(void) = 0;
	virtual float Perimeter(void) = 0;
	//virtual void translate (int x, int y) = 0;
	virtual void print(void) = 0;
	virtual float get(void) = 0;
};

class Triangle : public Shape
{
public:
	void Create();
	float Area();
	float Perimeter();
	void print();
	//void translate(int x, int y);
	float get() //tova kakvo ni dava?
	{
		return S;
	}

private:
	float a;
	float b;
	float c;
	float h;
	float S;
	float P;
};

void Triangle::Create()
{
	float a1;
	float b1;
	float c1;
	float h1;

	do 
	{
		cout << "Trqbva da vavedete nujnata informaciq za TRIAGALNIK !" << endl;
		
		cout << "Vavedete daljinata na stranata a:";
		cin >> a1;
		a = a1;

		cout << "Vavedete daljinata na stranata b:";
		cin >> b1;
		b = b1;

		cout << "Vavedete daljinata na stranata a:";
		cin >> c1;
		c = c1;

		cout << "vavedete daljinata na viso4inata kam a";
		cin >> h1;

		h = h1;
	}

	while (a1 > 0 && b1 > 0 && c1 > 0 && h1 > 0 &&
		  (a1 + b1) > c1 && (a1 + c1) > b1 && (c1 + b1) > a1); //usloviata ne sa taka
}

float Triangle::Area()
{
	S = ((a * h)/2);
	return S;
}

float Triangle::Perimeter()
{
	P = (a + b + c);
	return P;
}

void Triangle::print()
{
	cout << "Triagalnik sas strani:" << endl;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl;

	cout << "Ima lice S = " << S << endl;
	cout << "Ima i perimeter P = " << P << endl;
}

class Circle : public Shape
{
public:
	void Create();
	float Area();
	float Perimeter();
	void print();
	//void translate(int x, int y);
	float get()
	{
		return S;
	}

private:
	float S;
	float P;
	float r;
};

void Circle::Create()
{
	float r1;

	do
	{
		cout << "Vavedete radiusa na kraga: ";
		cin >> r1;
		r = r1;
	}

	while (r > 0); 
	
}

float Circle::Area()
{
	S = PI*r*r;
	return S;
}

float Circle::Perimeter()
{
	P = 2*PI*r;
	return P;
}

void Circle::print()
{
	cout << "Kraga s radius r = " << r << endl;
	cout << "Ima lice S = " << S << endl;
	cout << "Ima daljina C = " << P << endl; 
}

class Rectangle : public Shape
{
public:
	void Create();
	float Area();
	float Perimeter();
	void print();
	//void translate(int x, int y);
	float get()
	{
		return S;
	}
private:
	float a;
	float b;
	float S;
	float P;

};

void Rectangle::Create()
{
	float a1;
	float b1;

	do
	{
		cout << "vavedete daljinata na pravoagalnika:";
		cin >> a1;
		a = a1;

		cout << "vavedete 6irinata na pravoagalnika:";
		cin >> b1;
		b = b1;
	}
	while (a > 0 && b > 0); //usloviata sa naobratno, tova ne e repeat/until ;)
}

float Rectangle::Area()
{
	S = a*b;
	return S;
}

float Rectangle::Perimeter()
{
	P = 2*(a+b);
	return P;
}

void Rectangle::print()
{
	cout << "Pravoagalnika sas strani a = " << a << " i b = " << b << endl;
	cout << "Ima lice S = " << S << "i perimetar P = " << P << endl; 
}


class Square : public Rectangle
{
public:
	void Create();
	float Area();
	float Perimeter();
	void print();
	//void translate(int x, int y);
	float get()
	{
		return S;
	}
private:
	float a;
	float S;
	float P;

};

void Square::Create()
{
	float a1;


	do
	{
		cout << "vavedete stranata na kvadrata:";
		cin >> a1;
		a = a1;

	}
	while (a > 0); //triabva while a < 0
}

float Square::Area()
{
	S = a*a;
	return S;
}

float Square::Perimeter()
{
	P = 4*a;
	return P;
}

void Square::print()
{
	cout << "Kvadrata sas strani a = " << a << endl;
	cout << "Ima lice S = " << S << "i perimetar P = " << P << endl; 
}


class Con
{
public:
	void Addshape();
	void printShape(int);
	void calculateAllArea();
	void SaveToFile(char*);
private:
	Shape *Shapes[10];
	int number;
};

void Con::Addshape()
{
	//Shape *arr[10];


	Triangle t;
	Circle c;
	Rectangle r;
	Square s;

	cout << "Za kakva figura iskate da vavedete informaciq 1-za Triagannik";
	cout << "2 -  krag 3 za pravoagalnik 4 za kvadrat:" << endl;

	int k;
	cin >> k;

	if (k == 1) 
	{
		t.Create();
		for (int i = 0; i < 10; i++)
		{
			if( Shapes[i] == '\0') Shapes[i] = &t; //otkude idva tova \0 ??? po podrazbirane vsichki Shapes[i] sa neustanoveni
		}
	} 
	
	if (k == 2) 
	{
		c.Create();
		for (int i = 0; i < 10; i++)
		{
			if( Shapes[i] == '\0') Shapes[i] = &c;
		}
	} 

	if (k == 3) 
	{
		r.Create();
		for (int i = 0; i < 10; i++)
		{
			if( Shapes[i] == '\0') Shapes[i] = &r;
		}
	} 

	if (k == 4) 
	{
		s.Create();
		for (int i = 0; i < 10; i++)
		{
			if( Shapes[i] == '\0') Shapes[i] = &s;
		}
	} 

}

void Con::printShape(int number)
{
	for (int i = 0; i < 10; i++)
	{
		if (i == number) Shapes[i]->print(); 
	}
}

void Con::calculateAllArea()
{
	float sum = 0;
	for (int i = 0; i < 10; i++)
	{	
		sum += (Shapes[i] -> get()); //zashto ti e get(), kato imash Area() ?
	}

	cout << "Sumata na licata na vsi4ki figuri e = " << sum << endl;
}

void Con::SaveToFile(char* filename)
{
	ofstream onf;
	onf.open(ios::out); //triabva open(filename,ios::out)
	for(int i = 0; i < 10; i++)
	{
		onf << "Figura nomer " << i << " ima lice S = " << Shapes[i]->get();
	}
	onf.close();
}

void main () {}






