#include<iostream>
#include<cmath>
using namespace std;
class Point
{
public:
	double dist(Point & p)
	{
		return sqrt((p.getX()-x)*(p.getX()-x)+(p.getY()-y)*(p.getY()-y));
	}
	double getX(){return x;}
	double getY(){return y;}
	void setX(double a){x=a;}
	void setY(double a){y=a;}
private:
	double x,y;
};
class Shape
{
public:
	~Shape(){delete[]points;}
	virtual void create()=0;
	virtual double area()=0;
	virtual double perimeter()=0;
	virtual void print()=0;
	//virtual void translate(Point ,Point)=0;
protected:
	Point *points;
};
class Triangle:public Shape
{
public:
	Triangle();
	Triangle(Point*);
	void create();
	double area();
	double perimeter();
	void print();
	//void translate(Point ,Point);
};
Triangle::Triangle()
{
	points=new Point[3];
}
Triangle::Triangle(Point *p)
{
	for(int i=0;i<3;i++)
		points[i]=p[i];
}
void Triangle::create()
{
	double t;
	for(int i=0;i<3;i++)
	{
		cout<<"X=";
		cin>>t;
		points[i].setX(t);
		cout<<"Y=";
		cin>>t;
		points[i].setY(t);
	}
}
double Triangle::area()
{
	return points[0].getX()*points[1].getY()
		+points[2].getX()*points[0].getY()
		+points[1].getX()*points[2].getY()
		-points[2].getX()*points[1].getY()
		-points[1].getX()*points[0].getY()
		-points[0].getX()*points[2].getY(); //kak stigash do tazi formula?
}
double Triangle::perimeter()
{
	return points[0].dist(points[1])+points[0].dist(points[2])
		+points[1].dist(points[2]);
}
void Triangle::print()
{
	for(int i=0;i<3;i++)
	{
		cout<<"X"<<i<<':'<<points[i].getX();
		cout<<"Y"<<i<<':'<<points[i].getY();
	}
}

class Rectangle: public Shape
{
public:
	Rectangle();
	void create();
	double area();
	double perimeter();
	void print();
};
Rectangle::Rectangle()
{
	points=new Point[4];
}
void Rectangle::create()
{
	double t;
	for(int i=0;i<4;i++)
	{
		cout<<"X=";
		cin>>t;
		points[i].setX(t);
		cout<<"Y=";
		cin>>t;
		points[i].setY(t);
	}
}
double Rectangle::area()
{
	Triangle t(points);
	return 2*t.area();
}
double Rectangle::perimeter()
{
	return points[0].dist(points[1])+points[1].dist(points[2])
		+points[2].dist(points[3])+points[3].dist(points[0]);
}
void Rectangle::print()
{
	for(int i=0;i<4;i++)
	{
		cout<<"X"<<i<<':'<<points[i].getX();
		cout<<"Y"<<i<<':'<<points[i].getY();
	}
}
class Circle :public Shape
{
public:
	Circle(){points=new Point;}
	void create();
	double area();
	double perimeter();
	void print();
private:
	double r;
};
	void Circle::create()
	{
		double t;
		cout<<"X=";
		cin>>t;
		points->setX(t);
		cout<<"Y=";
		cin>>t;
		points->setY(t);
		cout<<"Radius:";
		cin>>r;
	}
	double Circle::area()
	{
		return 3.14*r*r;
	}
	double Circle::perimeter()
	{
		return 3.14*r*2;
	}
	void Circle::print()
	{
		cout<<"X"<<':'<<points->getX();
		cout<<"Y"<<':'<<points->getY();
		cout<<"Radius:"<<r;
	}

	//niamash Shapes chastta ot zadachata