// SVETLIN ZAMFIROV 44605
#include <iostream>
#include <fstream>

using namespace std;

class Sequence{
	char* el;
public:
	Sequence();
	Sequence(char *);
	Sequence(const Sequence&);
	~Sequence();
	Sequence& operator=(const Sequence&);
	char* operator^(Sequence&); //tuk sledva da se vrushta Sequence, ne char*
	char operator()(int,int); //i tuk Sequence
	Sequence Replace(char,Sequence&);
	void Load();
	void Store();
	void print(){
		cout<<el;
	}
};

int length(const char* p){ 
    const char *s;
    for (s = p; *s; ++s); //s ne moje da se promenia zashtoto e const
    return(s - p);
}

Sequence::Sequence(){
	this->el=0;
}

Sequence::Sequence(char* e){
	el=new char[length(e)+1];
	strcpy(el,e);
}

Sequence::Sequence(const Sequence& s){
	el=new char[length(s.el)+1];
	strcpy(el,s.el);
}

Sequence::~Sequence(){delete[]el;}
Sequence& Sequence::operator =(const Sequence& s){
	if(this!=&s){
		//triabva: if (el) delete [] el;
		el=new char[length(s.el)+1];
		strcpy(el,s.el);
	}
	return *this;
}

char Sequence::operator ()(int a,int b){
	if(a<b){
		for(int i=a;i<b;i++){
			return el[i]; //??? taka prosto vrushtash simvola na pozicia a. triabva da vurnesh ciala podredica mejdu pozicii a i b
		}
	}
	else cout<<"Bad input\n";
}

char* Sequence::operator^(Sequence& s){
	char* p=new char[length(this->el)+1];
	for(int i=0;i<length(this->el);i++)
		for(int j=i;j<length(s.el);j++){
			if(this->el[i]!=s.el[j]){ //obratnoto
				p[i]=this->el[i]; 
			}
		}
	return p;
}

Sequence Sequence::Replace(char item,Sequence& replacement){
	Sequence a;
	a.el=new char[length(this->el)+length(replacement.el)];
	//ne e viarno: v nai-loshia sluchai novata duljina e length(el)*length(replacement.el), a ne +
	for(int i=0;i<length(this->el)+1;i++){
		if(this->el[i+1]==item){
			a.el[i]=el[i];
			for(int j=i+1;j<length(replacement.el)+1;j++){
				a.el[j]=replacement.el[j];}
			if(i!=length(this->el))
			i++;
		}
		a.el[i]=el[i];
	}
	return a;
}

void Sequence::Load(){
	ifstream fin("file.txt");
	while(fin.good()) 
		cout<<fin.get(); //load ne triabva da izvejda na ekrana, a triabva da napulni el s prochetenoto ot faila
	fin.close();
}

void Sequence::Store(){
	ofstream fout("file.txt",ios::app);
	fout<<el<<endl; 
	fout.close();
}

int main(){
	char c;
	Sequence p("1 2 3 4");
	Sequence q("1 1 9");
	cout<<"replace: ";
	cin>>c;
	cout<<endl;
	p.Replace(c,q);
	Sequence m=p^q;
	m.print();
	return 0;
}
	
