#include <iostream>
#include <string>
using namespace std;


int strlen1(const char* s); 

class Sequence {

	char* arr;
	int len;
	
	public:

	Sequence(): arr(NULL), len(0) {} 
	Sequence(const Sequence& s) {
		len = s.len;
		arr = new char[len+1];
		for(int i=0;i<len;i++) arr[i] = s.arr[i];
		//strcpy(arr,s.arr);
	}
	Sequence& operator=(const Sequence& s) {
	
		if(this!=&s) {
			delete arr;
			len = s.len;
			arr = new char[(s.len)+1];
			for(int i=0;i<len;i++) arr[i] = s.arr[i];
		}
		return *this;
	}
	~Sequence() { delete arr; }

	Sequence(const char* str) {
		len = strlen1(str);
		arr = new char[len+1];
		for(int i=0;i<len;i++) arr[i] = str[i];
	}

	void print() const {
		for(int i=0; i<len; i++) cout << arr[i];
		cout << endl;
	}

	bool operator<(const Sequence& s) {
		bool flag = 0;
		for(int i=0; i<len; i++){ //ne mojesh da obikaliash do len, zashtoto s.len moje da e po-malko
			 if(arr[i]<s.arr[i]) flag = 1;
		}
		//ne e suvsem taka, tuk triabva da im sravnish duljinite
		return flag;
	}
	
	Sequence operator+(const Sequence& s) {
		
		Sequence newSeq; //= new Sequence;
		newSeq.len = len + s.len;
		newSeq.arr = new char[len+s.len+1];
		for(int i=0; i<len; i++) newSeq.arr[i] = arr[i];
		for(int i=0; i<s.len; i++) newSeq.arr[i+len] = s.arr[i];
		
		return newSeq;
	}

	int subsearch(const Sequence& s) {
		int returnIndex = -1;
		if(strlen(s.arr)>strlen(arr)) return returnIndex;
		else { 
			//bool flag = 0;
			bool flag2;
			for(int i=0;i<len;i++) {
				if(arr[i]==s.arr[0]) {
					for(int j=1;j<s.len;j++) {
						if(arr[i+j]==s.arr[j]) flag2 = 1;
						else flag2 = 0;
					}
					if(flag2==1) returnIndex = i; 
				}
			}
		}; 
			
		return returnIndex;
	}
			

};



int strlen1(const char* s) {
	int count=0;
	int i=0;
	while(s[i]!='\0') {
		count++;
		i++;
	}
	return count;
}



/*
void strcpy(char* s1, char* s2) { 
	if(strlen1(s1)==strlen1(s2)) {
		for(int i=0;i<strlen1(s1);i++) s1[i] = s2[i];
	}
}
*/



	



int main() {

	

	Sequence s1("3712");
	Sequence s2("512");

	Sequence s3 = s1+s2;
	
	cout << "s1: "; s1.print();
	cout << "s2: "; s2.print();
	cout << "s3 = s1+s2: "; s3.print();

	cout << "s1<s2?: ";
	if(s1<s2) cout << "Yes" << endl;
	else cout << "No." << endl;
	


	Sequence t1("74313");
	cout << "t1: "; t1.print();
	Sequence ts("31");
	cout << "ts: "; ts.print();
	cout << "t1 contains ts in index: ";
	cout << t1.subsearch(ts) << endl;
	


	
}		
		

