//Albena Kyoseva 2grupa 44642
//1zad
#include <iostream>     
using namespace std;

template <class T> //tova zashto si go ostavila, ako ne go polzvash? sega ne ti se kompilira
class Sequence
{
    char*element;
public:
    Sequence(){
        element = NULL;
    }
    ~Sequence(){
        delete[]element;
    }
    Sequence(const Sequence&);
    Sequence& operator=(const Sequence& s);
    char operator^(Sequence& s);
}
Sequence::Sequence(const Sequence& s)
{
    if (element!=NULL){ //a ako e NULL? zashto ima takava proverka v konstruktor??
        element = new T(s.element); //posledno T li polzvash ili char? i v dvata sluchaia ti triabva masiv new T[strlen(s.element)+1]
    }
}
Sequence& Sequence::operator =(const Sequence& s)
{
    if(this != &s){
        delete()element; //niama takova neshto delete ()
        element = new T(s.element); //kato gore
    }
    return *this;
}


 //2zad
#include <iostream>
#include <string.h>

using namespace std;

class EatingCreature {
  protected:
    char *name;
    double weight;
    double dailyDistance;
  public:
    virtual double dailyEnergyCons() = 0;
    virtual double dailyFoodCons() = 0;
    //virtual double distanceWithFood(double foodAmount) = 0;
    double distanceWithFood(double foodAmount) {
      return dailyDistance * (foodAmount / dailyFoodCons()); //bravo, tochno tova e formulata, bonus :P
    }
    virtual void print() = 0;
};

class Dog : EatingCreature {
  public:
    Dog(char *in_name, double in_weight, double in_dailyDistance) {
      in_name = new char[strlen(in_name)+1];
      strcpy(name, in_name);
      weight = in_weight;
      dailyDistance = in_dailyDistance;
    }
    ~Dog() {
      delete name;
    }
    void print() {
      cout<<"Type: Dog"<<endl;
      cout<<"Name: "<<name<<endl;
      cout<<"Weight: "<<weight<<endl;
      cout<<"DailyDistance: "<<dailyDistance<<endl;
    }
};

class American : EatingCreature {
  protected:
    int dailyMCD;
  public:
    American(char *in_name, double in_weight, double in_dailyDistance, int in_dailyMCD) {
      in_name = new char[strlen(in_name)+1];
      strcpy(name, in_name);
      weight = in_weight;
      dailyDistance = in_dailyDistance;
      dailyMCD = in_dailyMCD;
    }
    ~American() {
      delete name;
    }
    void print() {
      cout<<"Type: American"<<endl;
      cout<<"Name: "<<name<<endl;
      cout<<"Weight: "<<weight<<endl;
      cout<<"DailyDistance: "<<dailyDistance<<endl;
      cout<<"Daily MCD: "<<dailyMCD<<endl;
    }
    double dailyEnergyCons() {
      return 0.1*dailyDistance*weight;
    }
    double dailyFoodCons() {
      double energy = dailyEnergyCons();
      return energy + 0.2*dailyMCD*energy;
    }
};

class Woman : EatingCreature {
  protected:
    int age;
    int nervousness;
  public:
    Woman(char *in_name, double in_weight, double in_dailyDistance, int in_age, int in_nervousness) {
      in_name = new char[strlen(in_name)+1];
      strcpy(name, in_name);
      weight = in_weight;
      dailyDistance = in_dailyDistance;
      age = in_age;
      nervousness = in_nervousness;
    }
    ~Woman() {
      delete name;
    }
    void print() {
      cout<<"Type: Woman"<<endl;
      cout<<"Name: "<<name<<endl;
      cout<<"Weight: "<<weight<<endl;
      cout<<"DailyDistance: "<<dailyDistance<<endl;
      cout<<"Age: "<<age<<endl;
      cout<<"Nervousness: "<<nervousness<<endl;
    }
    double dailyEnergyCons() {
      return dailyDistance*weight*nervousness;
    }
    double dailyFoodCons() {
      double energy = dailyEnergyCons();
      if (age<=12)
 return energy;
      if (age>12 && age<42)
 return 0.5*energy;
      if (age>=42)
 return 1.15*energy;
    }
};

void findTheOne(double amountOfFood, EatingCreature *array, int len) { //ne mojesh da izpolzvash dumata array, vij che ia pravi v sinio ;)
  double maxDistance = array[0].distanceWithFood(amountOfFood), curDistance;
  int maxIndex = 0;
  for (int i=1; i<len; i++) {
    curDistance = array[i].distanceWithFood(amountOfFood);
    if (curDistance > maxDistance) {
      maxDistance = curDistance;
      maxIndex = i;
    }
  }
  array[maxIndex].print();
}
