#include <iostream>
#include <math.h>
using namespace std;

const double PI=3.141592654;
class Shape
{
public:
	virtual void Create()=0;
	virtual float Area()=0;
	virtual float Perimeter()=0;
	virtual void translate(int x, int y);
	virtual void print();
};

class Triangle: public Shape
{public:
	Triangle(){Create();}
	int x1,x2,x3,y1,y2,y3;
	void Create()
	{
		cout<<"Vuvedete kordinati za purvata tochka:";
		cin>>x1>>y1;
		cout<<endl<<"Vuvedete kordinati za vtorata tochka:";
		cin>>x2>>y2;
		cout<<endl<<"Vuvedete kordinati za tretata tochka:";
		cin>>x3>>y3;
		cout<<endl;
	}
	float line1(){ return ((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))^(1/2);}
	float line2(){ return ((x3-x2)*(x3-x2)+(y3-y2)*(y3-y2));}
	float line3(){ return ((x1-x3)*(x1-x3)+(y1-y3)*(y1-y3));}
	float Perimeter(){ return (line1()+line2()+line3());}
	void translate (int x, int y){ x1+=x; y1+=y; x2+=x; y2+=y; x3+=x; y3+=y;}
	float Area() { return sqrt(((Perimeter()/2)*((Perimeter()/2)-line1())*((Perimeter()/2)-line2())*((Perimeter()/2)-line3())));}
	void print()
	{
		cout<<"kordinati za purvata tochka:"<<x1<<" "<<y1<<endl;
		cout<<"kordinati za vtorata tochka:"<<x2<<" "<<y2<<endl;
		cout<<"kordinati za tretata tochka:"<<x3<<" "<<y3<<endl;
	}

};
class Circle: public Shape
{
public:
	int x1,y1,r;
	Circle(){Create();}
	void Create()
	{
		cout<<"Vuvedete kordinati za tochkata:";
		cin>>x1>>y1;
		cout<<endl<<"Vuvedete kordinati za radiusa";
		cin>>r;
		cout<<endl;
	}
	float Perimeter()
	{
		return 2*PI*r;
	}
	void translate (int x, int y){ x1+=x; y1+=y;}
	float Area(){return PI*r*r;}
	void print()
	{
		cout<<"kordinati za tochkata sa:"<<x1<<" "<<y1<<endl;
		cout<<"Radiusa e:"<<r<<endl;
	}

};
class Rectangle: public Shape
{
public:
	Rectangle(){Create();}
	int x1,x2,y1,y2;
	void Create()
	{
		cout<<"Vuvedete kordinati za purvata tochka:";
		cin>>x1>>y1;
		cout<<endl<<"Vuvedete kordinati za vtorata tochka:";
		cin>>x2>>y2;
	}
	float Perimeter()
	{ 
		if(x1>x2&&y1>y2) return (x2-x1)*2+(y2-y1)*2;
		else if(x1<x2&&y1>y2) return (x1-x2)*2+(y2-y1)*2;
		else if(x1<x2&&y1<y2) return (x1-x2)*2+(y1-y2)*2;
		else if(x1>x2&&y1<y2) return (x2-x1)*2+(y1-y2)*2;
		else return 0;
	}
	void translate (int x, int y){ x1+=x; y1+=y; x2+=x; y2+=y;}
	float Area()
	{	if(x1>x2&&y1>y2) return (x2-x1)*(y2-y1); //tezi formuli rabotiat samo ako pravougulnikut e usporeden na koordinatnite osi
		if(x1<x2&&y1>y2) return (x1-x2)*(y2-y1); //po-dobre napishi funkcia za duljina na otsechka mejdu dve tochki i polzvai neia
		if(x1<x2&&y1<y2) return (x1-x2)*(y1-y2);
		if(x1>x2&&y1<y2) return (x2-x1)*(y1-y2);
		else return 0;
	}
	void print()
	{
		cout<<"kordinati za purvata tochka:"<<x1<<" "<<y1<<endl;
		cout<<"kordinati za vtorata tochka:"<<x2<<" "<<y2<<endl;
	}



};
class Square:public Rectangle
{}; //implementacia?


class Shapes
{
public:
	Shape *T;
	int size;
void 	AddShape()
	{
		cout<<"Kakva figura da dobavim?1-Triangle,2-Circle,3-Rectangle,4-Square";
		int x;
		cin>>x;
		Shape *t;
		if(x==1)Triangle *t=new Triangle;
		else if(x==2)Circle *t = new Circle;
		else if(x==3)Rectangle *t= new Rectangle;
		else Square *t = new Square;
		T[size]=*t; //triabva T[size] = t; vij dolu
		size++;
}

void printShape(int number)
{
	for(int i=0;i<size;i++)
	{
		cout<<"Figura nomer"<<i<<":";
		T[i].print();
		cout<<endl;
	}
}
void calculateAllArea()
{
	float Areas=0.0;
	for(int i=0;i<size;i++)
	{
		Areas+=T[i].Area(); //za da se vikat virtualni funkcii, triabva da se izpolzvat ukazateli, masivut triabva da e Shape** T
	}
	cout<<"Sbor ot licata na vsichki figuri"<<Areas<<endl;
}

};