template<class T>
class Bag
{
private:
	T* bag;
	int n;
	int c;//current position
	void copy(const Bag&);
public:
	Bag(int n);
	~Bag();
	Bag(const Bag&);
	Bag& operator=(const Bag &);
	bool operator+=(T); //Joro: po-dobre e T&, ne znaem kolko e goliam obektut i dali ne e trudoemko da se kopira
	Bag operator^(const Bag&);
	int lenght()const;
	void print()const;
};
template<class T>
Bag<T>::Bag(int x)
{
	n=x;
	c=-1;
	bag= new T[n];
}
template<class T>
Bag<T>::~Bag()
{
	delete[] bag;
}
template<class T>
void Bag<T>::copy(const Bag<T>& b)
{
	n=b.n;
	c=b.c;
	bag=new T[n];
	for(int i=0;i<=c;i++)
		bag[i]=b.bag[i];
}
template<class T>
Bag<T>::Bag(const Bag<T> &b)
{
	copy(b);
}
template<class T>
Bag<T>& Bag<T>::operator =(const Bag<T> &b)
{
	if(this!=&b)
	{
		delete[]bag;
		copy(b);
	}
	return *this;
}
template<class T>
bool Bag<T>::operator +=(T t)
{
	c++; //tozi red triabva da e sled dolnia, inache length() vrushta greshni danni
	if(c>=n)return false; //po uslovie multimnojestvoto triabva da e neogranicheno, makar che ne go schitam za greshka
	bag[c]=t;
	return true;
}
template<class T>
Bag<T> Bag<T>::operator^(const Bag<T> &b) //logikata ti e greshna, ti si pravil obedinenie, a triabva sechenie
{
	Bag new_b(n+b.n);
	for(int i=0;i<c+1;i++)
	{
		new_b.bag[i]=bag[i];
		new_b.c++;
	}
	int i=0;
	for(int j=c+1;j<b.c+c+4;j++)
	{
		
		new_b.bag[j]=b.bag[i];
		new_b.c++;
		i++;
	}
	new_b.c--;
	return new_b;
}
template<class T>
int Bag<T>::lenght() const
{
	return c;
}
template<class T>
void Bag<T>::print() const
{
	for(int i=0;i<=c;i++)
		cout<<*(bag+i)<<"/";
	cout<<endl;
}