template<class T> //klasut ti prepisva vsichko ot Bag, kakuv e smisulut da go naslediava togava? Triabva da preizpolzvash nasledenite metodi
class Set
{
public:
	T* set;
	int n;
	int c;//current position
	void copy(const Set&);
public:
	Set(int n);
	~Set();
	Set(const Set&);
	Set& operator=(const Set &);
	bool operator+=(T);
	Set operator^(const Set&);
	int lenght()const;
	void print()const;
};
template<class T>
Set<T>::Set(int x)
{
	n=x;
	c=-1;
	set= new T[n];
}
template<class T>
Set<T>::~Set()
{
	delete[] set;
}
template<class T>
void Set<T>::copy(const Set<T>& b)
{
	n=b.n;
	c=b.c;
	set=new T[n];
	for(int i=0;i<=c;i++)
		set[i]=b.set[i];
}
template<class T>
Set<T>::Set(const Set<T> &b)
{
	copy(b);
}
template<class T>
Set<T>& Set<T>::operator =(const Set<T> &b)
{
	if(this!=&b)
	{
		delete[]set;
		copy(b);
	}
	return *this;
}
template<class T>
bool Set<T>::operator +=(T t)
{
	c++;
	if(c>=n)return false;
	set[c]=t;
	return true;
}
template<class T>
Set<T> Set<T>::operator^(const Set<T> &b)  //otnovo ne pravish sechenie, sechenieto sa samo elementite v this i b ednovremenno
{
	Set new_s(n+b.n);
	for(int i=0;i<c+1;i++)
	{
		new_s.set[i]=set[i];
		new_s.c++;
		
	}
	
	int j=c+1;
	for(int i=0;i<b.c+1;i++)
	{
		bool a=true;
		for(int t=0;t<c+1;t++)
			if(b.set[i]==set[t]) a=false;
		if(a)
		{
			cout<<'!'; //tova zashto e?
			new_s.set[j]=b.set[i];
			j++;
			new_s.c++;
		}
	}
	return new_s;
}
template<class T>
int Set<T>::lenght() const
{
	return c;
}
template<class T>
void Set<T>::print() const
{
	for(int i=0;i<=c;i++)
		cout<<*(set+i)<<"/";
	cout<<endl;
}