// kontolno n2.cpp : Defines the entry point for the console application

#include<iostream>
using namespace std;

template<class T>
struct element
{
	T data;
	element* link;
} //triabva ;

template<class T>
class List
{
public:
	List()
	{
		start=end=NULL;
		len=0;
	}
	List(const List& L); //niama ; zashto ne kompilirash?
	{
		copy(L);
	}
	~List()
	{
		del();
	}
	List& operator=(const List& L)
	{
		if(this!=&L)
			del();
		copy(L);
		return *this;
	}
	bool AddElement(T);
	bool AddSortedEl(T);
	int Lenght() const;
	bool isempty()const;
	bool iscontained(T)const;
	element* NewElement(T); //triabva element<T>
	List both(const List&);
	void print()const;
private:
	void copy(const List& L);
	void del();
	element* start,end; //sushto
	int len;
};

template<class T>
void List::copy(const List& L) //triabva List<T>. sushtata greshka navsiakude nadolu
{
	if(L.isempty()){del();return;}
	del(); //zashto sa tia del(), nali navsiakude i navun ot copy gi vikash?
	start=end=NewElement(L.start->data);
	*p=L.start->link; //triabva element<T>* p; sushtoto navsiakude nadolu
	while(p)
	{
		AddElement(p->data);
		p=p->link;
	}
	len=L.len;
}

template<class T>
void List::del()
{
	if(isempty())return;
	element *p=start;
	while(start)
	{
		start=start->link
		delete p;
		p=start;
	}
	end=NULL;
}

template<class T>
bool List::AddElement(T inf) //po-dobre T&
{
	element *p=NewElement(inf);
	if(!p)return 0;
	end->link=p;
	end=p;
	len++;
	return 1;
}

template<class T>
int List::Lenght()const
{
	return len;
}

template<class T>
bool List::isempty()const
{
	return start==NULL;
}

template<class T>
element* List::NewElement(T inf)
{
	element *p=new element;
	p->data=inf;
	p->link=NULL;
	return p;
}
template<class T>
bool List::iscontained(T inf)const
{
	element *p=start;
	while(p)
	{
		if(p->data==inf)return 1;
		p=p->link;
	}
	return 0;
}

template<class T>
List List::both(const List& L)
{
	List NL;
	element *p=start;
	while(p)
	{
		if(L.iscontained(p->data))NL.AddElement(p->data);
		p=p->link;
	}
	return NL;
}
template<class T>
bool List::AddSortedEl(T id)
{
	element *p=start,*c=start->link;
	element *ne=NewElement(id);
	if(!ne)return 0; //false
	if(id<=p->data)
	{
		ne->link=start;
		start=ne;
		return 1;
	}
	if(id>=end->data)
	{
		end->link=ne;
		end=ne;
		return 1;
	}
	while(c)
	{
		if(id<c->data)
		{
			p->data=ne;
			ne->link=c;
			return 1;
		}
		p=c;
		c=c->link;
	}
	return 0;
}

template<class T>
void List::print()const;
{
	element* p=start;
	while(p);
	{
		cout<<p->data<<" ";
		p=p->link;
	}
	cout<<endl;
}

template<class T>
class bag
{
public:
	bag(){};
	bag(const List&);
	bag(const bag&);
	bag& operator=(const bag&);
	int lenght()const;
	bool operator+=(T);
	bag operator^(const bag&);
	void print()const;
private:
	List bagL; //triabva List<T>, kakto i navsiakude nadolu
};

template<class T>
bag::bag(const List& L)
{
	bagL=L;
}
template<class T>
bag::bag(const bag& b)
{
	bagL=b.bagL;
}

template<class T>
bag& bag::operator=(const bag& b)
{
	//proverka za if this != &b
	bagL=b.bagL;
	return *this;
}

template<class T>
int bag::lenght()const
{
	return bagL.lenght;
}

template<class T>
bool bag::operator+=(T inf)
{
	return bagL.AddElement(inf);
}

template<class T>
bag operator^(const bag& ob)
{
	bag NB(bagL.both(ob.bagL));
	return NB;
}
template<class T>
void bag::print()const
{
	bagL.print();
}


template<class T>
class set
{
public:
	set(){};
	set(const List&);
	set(const set&);
	set& operator=(const set&);
	bool operator+=(T);
	set operator^(const set&);
	int lenght()const;
	void print()const;
private:
	List setL;
};

template<class T>
set(const List& L)
{
	setL=L;
}

template<class T>
set(const set& s)
{
	setL=s.setL;
}

template<class T>
set& operator=(const set& s)
{
	//kato gore, lipsva i return *this;
	setL=s.setL;
}

template<class T>
bool operator+=(T inf)
{
	return setL.AddSortedEl(inf); //addSortedEl dopuska povtorenia, a Set ne triabva da dopuska povtorenia
}

template<class T>
set operator^(const set& os)
{
	set NS(setL.both(os.setL));
	return NS;
}

template<class T>
int lenght()const
{
	return setL.lenght;
}
template<class T>
void print()const
{
	setL.print();
}

int main()
{
	set S,D;
	S+=5;D+=5;
	S+=6;D+=7;
	(S^D)print();
	bag B,A;
	B+=6;A+=7;
	B+=7;A+=8;
	(B^A).print();
	cout<<D.lenght()<<endl;
	cout<<B.lenght();
	return 0;
}