#include<iostream>
#include<cmath>
using namespace std;

class Point
{
public:
	Point(double x=0,double y=0):x(x),y(y){}
	void operator()(int a,int b)
	{
		x+=a;
		y+=b;
	}
	void print()
	{
		cout<<x<<" "<<y<<endl;
	}
	friend double distance(Point A,Point B) //friend funkciite ne se pishat v tialoto na klasa, zashtoto ne sa metodi! Osven tova e po-dobre Point&
	{
		Point V(B.x-A.x,B.y-A.y);
		return sqrt(x*x+y*y); //tuk triabva V.x i V.y
	}
private:
	double x,y;
};


class Shape
{
public:
	virtual void Create()=0;
	virtual float Area();
	virtual float Perimeter();
	virtual void translate(int,int);
	virtual void print();
};

class Triangle : public Shape
{
private:
	float a,b,c;
	Point A,B,C;
public:
	virtual void Create();
	virtual float Area();
	virtual float Perimeter();
	virtual void translate(int,int);
	virtual void print();
};

void Triangle::Create()
{
	
	float aa,bb;
	cout<<"Vuvedete koordinati za tochkata A:\n";
	cin>>aa>>bb;
	A(aa,bb);
	cout<<"Vuvedete koordinati za tochkata B:\n";
	cin>>aa>>bb;
	B(aa,bb);
	cout<<"Vuvedete koordinati za tochkata C:\n";
	cin>>aa>>bb;
	a=distance(B,C);
	b=distance(A,C);
	c=distance(A,B);
}
float Triangle::Area()
{
	flaot p=(a+b+c)/2;
	return sqrt(p*(p-a)*(p-b)*(p-c));
}
float Triangle::Perimeter()
{
	return a+b+c;
}
void Triangle::translate(int a,int b)
{
	A(a,b);B(a,b);C(a,b); //cool :p
}
void Triangle::print()
{
	cout<<"a="<<a<<" "<<"b="<<b<<" "<<"c="<<c<<endl;
	A.print();
	B.print();
	C.print();
	cout<<"Area"<<Area()<<" "<<"Perimeter"<<Perimeter()<<endl;
}

class Circle : public Shape
{
private:
	float r;
	Point C;
public:
	virtual void Create();
	virtual float Area();
	virtual float Perimeter();
	virtual void translate(int,int);
	virtual void print();
};
void Circle::Create()
{
	cout<<"Vuvedete radius.\n";
	float rr;
	cin>>rr;
	r=rr;
	cout<<"Vuvedete koordinatite na centura.\n";
	float bb;
	cin>>rr>>bb;
	C(rr,bb);
}
float Circle::Area()
{
	return 3.14*r*r;
}
float Circle::Perimeter()
{
	return 3.14*2*r;
}
void Circle::translate(int a, int b)
{
	C(a,b);
}
void Circle::print()
{
	cout<<"Centur:";
	C.print();
	cout<<"radius:"<<r<<endl;
	cout<<"Area"<<Area()<<" "<<"Perimeter"<<Perimeter()<<endl;
}

class Rectangle : public Shape
{
protected:
	Point A,B,C,D;
	float a,b;
public:
	virtual void Create();
	virtual float Area();
	virtual float Perimeter();
	virtual void translate(int,int);
	virtual void print();
};

void Rectangle::Create()
{
	cout<<"Vuvedete koordinati za tochkata A:";
	float p,q;
	cin>>p>>q;
	A(p,q);
	cout<<endl;
	cout<<"Vuvedete koordinati za tochkata B:";
	cin>>p>>q;
	B(p,q);
	cout<<endl;
	cout<<"Vuvedete koordinati za tochkata C:";
	cin>>p>>q;
	C(p,q);
	cout<<endl;
	a=distance(A,B);
	b=distance(B,C);
	D=A;
	D(b,0);
}
float Rectangle::Area()
{
	return a*b;
}
float Rectangle::Perimeter()
{
	return 2*a+2*b;
}
void Rectangle::translate(int a, int b)
{
	A(a,b);
	B(a,b);
	C(a,b);
	D(a,b);
}
void Rectangle::print()
{
	cout<<"a="<<a<<" "<<"b="<<b<<endl;
	A.print();
	B.print();
	C.print();
	D.print();
	cout<<"Area"<<Area()<<" "<<"Perimeter"<<Perimeter()<<endl;
}
class Square : public Rectangle
{
public:
	void Create();
	void print();

};
void Square::Create()
{
	cout<<"Vuvedete koordinati za tochkata A:";
	float p,q;
	cin>>p>>q;
	A(p,q);
	cout<<endl;
	cout<<"Vuvedete koordinati za tochkata B:";
	cin>>p>>q;
	B(p,q);
	cout<<endl;
	a=b=distance(A,B);
}

void Square::print()
{
	cout<<"a="<<a<<endl;
	A.print();
	B.print();
	C.print();
	D.print();
	cout<<"Area"<<Area()<<" "<<"Perimeter"<<Perimeter()<<endl;
}

class Shapes
{
private:
	Shape* m[100];
public:
	void AddShape()
	{
		for(int i=0;i<100;i++)
		{
			cout<<"1.Triangle\n2.Circle\n3.Rectangle\4.Square\n";
			int a;
			cin>>a;
			case(a)
			{
case 1 : {Triangle T;a[i]=&T;break;} //ne e ok, zashtoto na kraia na bloka (sled break) obektut T shte se iztrie ot steka i a[i] pochva da sochi kum nishtoto
case 2 : {Circle T;a[i]=&T;break;}
case 3 : {Rectangle T;a[i]=&T;break;}
case 4 : {Square T;a[i]=&T;break;}
		 }
			a[i]->Creatr();
		}
	}



	




