//Ivan Borisov Ivanov
//fakulteten nomer 44583
#include<iostream>
#include<string.h>
#include<math.h>
using namespace std;
template <class T>
class elem
{
public:
	T data;
	elem* next;
};
template <class T> //bravo, samo ti si se setil, che niama nujda da ima cial spisuk vutre, a bag moje da e i takuv
class bag
{
protected:
	elem<T>* start;
public:
	bag(){start=NULL;}
	~bag();
	bag(bag& );
	bag<T>& operator= (bag<T>& );
	void add(T b);
	void print();
};
template <class T>
void bag<T>::print()
{
	if (!start) return;
	elem<T>* p=start;
	for (; p; p=p->next)
	{
		cout<<p->data<<' ';
	}
	cout<<"\n";
}
template <class T>
void bag<T>::add(T b)
{
	if (!start)
	{
		start= new elem<T>;
		start->data=b;
		start->next=NULL;
		return;
	}
	elem<T>* p=start;
	for (; p->next; p=p->next)
	{}
	p->next= new elem<T>;
	p->next->data=b;
	p->next->next=NULL;
}
template <class T>
bag<T>::~bag()
{
	if (!start) return;
	elem<T>* p=start;
	for (; start;)
	{
		p=start->next;
		delete[] start;
		start=p;
	}
}
template <class T>
bag<T>::bag(bag& t)
{
	start=NULL;
	elem<T>* p= t.start; 
	for (; p; p=p->next)
	{
		add(p->data);
	}
}
template <class T>
bag<T>& bag<T>::operator =(bag<T> &t)
{
	if (&start==&(t.start)) return *this;
	this->~bag(); //ne e dobre da se vika taka
	start=NULL;
	elem<T>* p=t.start;
	for (; p; p=p->next)
	{
		add(p->data);
	}
	return *this;
}


//dobre, no zashto metodite ot uslovieto sa realizirani samo za set, a ne i za bag? 

template <class T>
class set :public bag<T>
{
public:
	void add(T b)
	{
		if (!start)
		{
			start= new elem<T>;
			start->data=b;
			start->next=NULL;
			return;
		}
		if ((start->data)==b) return;
		elem<T>* p=start;
		for (; p->next; p=p->next)
		{
			if ((p->data)==b) { return;}
		}
		if ((p->data)==b) { return;}
		p->next= new elem<T>;
		p->next->data=b;
		p->next->next=NULL;
	}
	bool operator-= (T );
	set<T>& operator| (set<T>& ); //triabva da vurshtat nov set, a ne &
	set<T>& operator/ (set<T>& );
	bool search (T );

};
template <class T>
set<T>& set<T>::operator /(set<T> &t)
{
	set<T>* nov;
	nov= new set<T>;
	elem<T>* p= start;
	for (; p; p=p->next)
	{
		if (!(t.search(p->data))) nov->add(p->data);
	}
	return *nov; //ne mojesh da vrushtash reference kum neshto na steka, zashtoto to se unishtojava shtom svurshi tazi funkcia
}
template <class T>
bool set<T>::search (T b)
{
	elem<T>* p=start;
	for (; p; p=p->next)
	{
		if ((p->data)==b) return true;
	}
	return false;
}
template <class T>
set<T>& set<T>::operator |(set<T> &t)
{
	set<T>* nov;
	nov= new set<T>;
	elem<T>* p= start;
	for (; p; p=p->next)
	{
		nov->add(p->data);
	}
	p=t.start;
	for (; p; p=p->next)
	{
		nov->add(p->data);
	}
	return *nov;
}
template <class T>
bool set<T>::operator -=(T b)
{
	if (!start)
		{
			return false;
		}
		if ((start->data)==b)
		{
			elem<T>* p=start;
			start=start->next;
			delete[] p;
			return true;
		}
		elem<T>* p=start;
		for (; p->next; p=p->next)
		{
			if ((p->next->data)==b) 
			{ 
				elem<T>* q= p->next;
				p->next= p->next->next;
				delete[] q;
				return true;
			}
		}
		return false;
}
int main()
{
	bag<int> s1;
	s1.add(5); s1.add(6);
	bag<int> s2=s1;
	s2=s1;
	s1.print();
	s2.print();
	set<int> ss1;
	ss1.add(7);
	ss1.add(7);
	ss1.add(8);
	ss1.add(8);
	ss1.add(9);
	ss1.add(8);
	ss1.print();
	if (ss1-=8) cout<<"uspe6no izvaden element \n";
	cout<<"ss1: ";
	ss1.print();
	set<int> ss2;
	ss2.add(36);
	ss2.add(9);
	cout<<"ss2: ";
	ss2.print();
	cout<<"obedinqvam ss1 i ss2 ( ss1|ss2 )\n";
	set<int> ss3=(ss1|ss2);
	ss3.print();
	cout<<"razlikata ss1/ss2 e mnojestvoto : ";
	set<int> ss6=ss1/ss2;
	ss6.print();
	system("pause");
	return 0;
}

//a kude e drugata zadacha ??