//Angel Metaxov f.n. 44595
#include<iostream>
#include<string.h>
#include<math.h>
using namespace std;


//tazi zadacha e suvsem doslovno prepisana, osven che lipsvat dosta podtochki ot uslovieto ><

template <class G>
class element
{
public:
	T data;
	element* next;
};

template <class G>
class bag
{
protected:
	element<G>* start;
public:
	bag(){start=NULL;}
	~bag();
	bag(bag& ); 
	bag<G>& operator= (bag<G>& ); 
	void add(G b);
	void print();
};

template <class G>
void bag<G>::print()
{
	if (!start) return;
	element<G>* p=start;
	for (; p; p=p->next)
	{
		cout<<p->data<<' ';
	}
	cout<<"\n";
}
template <class G>
void bag<G>::add(G b)
{
	if (!start)
	{
		start= new element<G>;
		start->data=b;
		start->next=NULL;
		return;
	}
	element<G>* p=start;
	for (; p->next; p=p->next)
	{}
	p->next= new element<G>;
	p->next->data=b;
	p->next->next=NULL;
}
template <class G>
bag<G>::~bag()
{
	if (!start) return;
	element<G>* p=start;
	for (; start;)
	{
		p=start->next;
		delete[] start;
		start=p;
	}
}
template <class G>
bag<G>::bag(bag& t)
{
	start=NULL;
	element<G>* p= t.start;
	for (; p; p=p->next)
	{
		add(p->data);
	}
}
template <class G>
bag<G>& bag<G>::operator =(bag<G> &t)
{
	if (&start==&(t.start)) return *this;
	this->~bag();
	start=NULL;
	element<G>* p=t.start;
	for (; p; p=p->next)
	{
		add(p->data);
	}
	return *this;
}
template <class G>
class set :public bag<G>
{
public:
	void add(G b)
	{
		if (!start)
		{
			start= new element<G>;
			start->data=b;
			start->next=NULL;
			return;
		}
		if ((start->data)==b) return;
		element<G>* p=start;
		for (; p->next; p=p->next)
		{
			if ((p->data)==b) { return;}
		}
		if ((p->data)==b) { return;}
		p->next= new element<G>;
		p->next->data=b;
		p->next->next=NULL;
	}
	void operator-= (G);
};
template <class G>
void set<G>::operator -=(G b)
{
	if (!start)
		{
			return;
		}
		if ((start->data)==b)
		{
			element<G>* p=start;
			start=start->next;
			delete[] p;
			return;
		}
		element<G>* p=start;
		for (; p->next; p=p->next)
		{
			if ((p->next->data)==b) 
			{ 
				element<G>* q= p->next;
				p->next= p->next->next;
				delete[] q;
				return;
			}
		}
}
int main()
{
	bag<int> s1;
	s1.add(5); s1.add(6);
	bag<int> s2;
	s2=s1;
	s1.print();
	s2.print();
	set<int> ss1;
	ss1.add(7);
	ss1.add(7);
	ss1.add(8);
	ss1.add(8);
	ss1.add(9);
	ss1.add(8);
	ss1-=8;
	ss1.print();
	system("pause");
	return 0;
}