//Metodi Manolov
//fn 44608
//variant 2
//zad 1

#include <iostream>

using namespace std;

template <class T>
class Bag
{
 protected:
    T* mas;
    int n;        
 public:
    Bag(T* =0,int =0);
    Bag(const Bag&);
    Bag& operator=(const Bag &);
    ~Bag(){delete mas;}
    int size(){return n;} 
    bool operator+=(T);
    Bag operator^(Bag&);
    void print() {for(int i=0;i<n;i++) cout<<mas[i]<<"  ";cout<<endl;}
};

template <class T>
Bag<T>::Bag(T* m,int p)
{
    n=p;
    mas=new T[p];
    for(int i=0;i<p;i++) mas[i]=m[i];
}

template <class T>
Bag<T>::Bag(const Bag<T>& a)
{
    mas=new T[a.n];
    n=a.n;
    for(int i=0;i<n;i++)mas[i]=a.mas[i];
}

template <class T>
Bag<T>& Bag<T>::operator=(const Bag<T>& a)
{
    if(this==&a) return *this;
    delete mas;
    mas=new T[n]; //lipsva ti n=a.n;
    for(int i=0;i<n;i++) mas[i]=a.mas[i];
    return *this;
}

template <class T>
bool Bag<T>::operator+=(T s) //po-dobre e T&
{
    T* nmas=new T[++n];
    if(!mas) return false;
    nmas[0]=s;
    for(int i=1;i<n;i++) nmas[i]=mas[i-1];
    delete mas;
    mas=nmas;
    return true;
}

template <class T>
Bag<T> Bag<T>::operator^(Bag<T> &a)
{
    T newb[n+a.n]; //zashto? ako e sechenie, obshtiat broi ne moje da e poveche ot n
    int si=0;
    for(int i=0;i<n;i++)
        for(int j=0;j<a.n;j++) if (mas[i]==a.mas[j]) {
                                                     newb[si++]=mas[i];
                                                     break;
                                                    }
    Bag<T> xa(newb,si);
    return xa;
}
/////////////////////////////////////////////////////////////////////////////////
template <class T>
class Set:public Bag<T>
{
 public:
    Set(T* m=0,int p=0):Bag<T>(m,p){}
    Set(const Set& a):Bag<T>(a){};
    Set& operator=(const Set &);
    bool operator+=(T);
    Set operator^(Set&);
};

template <class T>
Set<T>& Set<T>::operator=(const Set<T>& a) //mojesh da polzvash Bag::operator=
{
    if(this==&a) return *this;
    delete mas;
    mas=new T[n];
    for(int i=0;i<n;i++) mas[i]=a.mas[i];
    return *this;
}

template <class T>
bool Set<T>::operator+=(T s)
{
   for(int i=0;i<n;i++) if (mas[i]==s) return false;
    T* nmas=new T[++n];
    if(!mas) return false;
    nmas[0]=s;
    for(int i=1;i<n;i++) nmas[i]=mas[i-1];
    delete mas;
    mas=nmas;
    return true
}

template <class T>
Set<T> Set<T>::operator^(Set<T> &a)
{
    T newb[n+a.n]; //kato gore, vsushtnost niama nujda da go prepisvash, to se naslediava ot Bag
    int si=0;
    for(int i=0;i<n;i++)
        for(int j=0;j<a.n;j++) if (mas[i]==a.mas[j]) {
                                                     newb[si++]=mas[i];
                                                     break;
                                                    }
    Set<T> xa(newb,si);
    return xa;
}

int main()
{
    Bag<int> a(0,0),b;
    Set<int> q;
    a+=5;
    a+=2;
    a+=3;
    a+=4;
    a.print();

    b+=2;
    b+=1;
    b+=5;
    b+=3;  
    b+=6;
    b+=9;
    b.print();

    Bag<int> c=a^b;
    c=a^b;
    c.print();

    cout<<c.size();
 system("pause");   
 return 0;
}
