//Metodi Manolov
//fn44608
//variant 2
//zad 2

#include <iostream>
#include <cmath>

using namespace std;
struct point
{float x,y;};

class Shape 
{
    public:
        virtual void Create()=0;
        virtual float Area()=0;
        virtual float Perimeter()=0;
        virtual void translate(float x,float y)=0;
        virtual void print()=0;
};

class Triangle:public Shape
{
    private:
        point p1,p2,p3;
    public:
        void Create();
        float Area();
        float Perimeter();
        void translate(float x,float y);
        void print();
};
void Triangle::Create()
{
    cout<<"Ax: ";cin>>p1.x;cout<<"Ay: ";cin>>p1.y;
    cout<<"Bx: ";cin>>p2.x;cout<<"By: ";cin>>p2.y;
    cout<<"Cx: ";cin>>p3.x;cout<<"Cy: ";cin>>p3.y;
}

float Triangle::Area()
{
 float a=sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
 float b=sqrt((p1.x-p3.x)*(p1.x-p3.x)+(p1.y-p3.y)*(p1.y-p3.y));
 float c=sqrt((p3.x-p2.x)*(p3.x-p2.x)+(p3.y-p2.y)*(p3.y-p2.y));
 float p=(a+b+c)/2;
 return sqrt(p*(p-a)*(p-b)*(p-c));
}

float Triangle::Perimeter()
{
    float a=sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
    float b=sqrt((p1.x-p3.x)*(p1.x-p3.x)+(p1.y-p3.y)*(p1.y-p3.y));
    float c=sqrt((p3.x-p2.x)*(p3.x-p2.x)+(p3.y-p2.y)*(p3.y-p2.y));
    return a+b+c;
}

void Triangle::translate(float x,float y)
{
 p1.x+=x;
 p1.y+=y;
 p2.x+=x;
 p2.y+=y;
 p3.x+=x;
 p3.y+=y;
}

void Triangle::print()
{
    cout<<"Ax: "<<p1.x<<"  Ay: "<<p1.y<<endl;
    cout<<"Bx: "<<p2.x<<"  By: "<<p2.y<<endl;
    cout<<"Cx: "<<p3.x<<"  Cy: "<<p3.y<<endl;
}

////////////////////////////////////////////////////////////////////////////////

class Circle:public Shape
{
    private:
        point p1;
        float r;
    public:
        void Create();
        float Area();
        float Perimeter();
        void translate(float x,float y);
        void print();
};

void Circle::Create()
{
  cout<<"Ax: ";cin>>p1.x;cout<<"Ay: ";cin>>p1.y;
  cout<<"R: ";cin>>r;
}

float Circle::Area()
{
    const float pi=3.14;
    return pi*r*r;
}

float Circle::Perimeter()
{
    const float pi=3.14;
    return 2*r*pi;   
}  

void Circle::translate(float x,float y)
{
    p1.x+=x;
    p1.y+=y;
}

void Circle::print()
{
    cout<<"Ax: "<<p1.x<<"  Ay: "<<p1.y<<"  R: "<<r<<endl;
}

/////////////////////////////////////////////////////////////////////////////////

class Rectangle:public Shape
{
    private:
        point p1,p2;
    public:
        void Create();
        virtual float Area();
        virtual float Perimeter();
        void translate(float x,float y);
        void print();
};

void Rectangle::Create()
{
    cout<<"Ax: ";cin>>p1.x;cout<<"Ay: ";cin>>p1.y;
    cout<<"Bx: ";cin>>p2.x;cout<<"By: ";cin>>p2.y;
}

float Rectangle::Area()
{
 float a=p2.x-p1.x;
 float b=p2.y-p1.y;
 return a*b;
}

float Rectangle::Perimeter()
{
    float a=p2.x-p1.x;
    float b=p2.y-p1.y;
    return 2*(a+b);
}

void Rectangle::translate(float x,float y)
{
 p1.x+=x;
 p1.y+=y;
 p2.x+=x;
 p2.y+=y;
}

void Rectangle::print()
{
    cout<<"Ax: "<<p1.x<<"  Ay: "<<p1.y<<endl;
    cout<<"Bx: "<<p2.x<<"  By: "<<p2.y<<endl;
}

////////////////////////////////////////////////////////////////////////////////

class Square:public Rectangle
{
    private:
        point p1,p2;
    public:
        float Area();
        float Perimeter();
};

float Square::Area()
{
 float a=p2.x-p1.x;
 return a*a;
}

float Square::Perimeter()
{
    float a=p2.x-p1.x;
    return 4*a;
}

class Shapes
{
    private:
        Shape * arr[100];
        int n;
    public:
        Shapes(){n=0;}
        void AddShape();
        void printShape(int number);
        void calculateAllArea();
};

void Shapes::AddShape()
{
    cout<<"Vavedi: T,C,R,S";
    char a;
    cin>>a;
    if (a=='T'){
                Shape* m=new Triangle;
                m->Create();
                arr[n++]=m;
                }
    if (a=='C'){
                Shape *m=new Circle;
                m->Create();
                arr[n++]=m;
                }
    if (a=='R'){
                Shape* m=new Rectangle;
                m->Create();
                arr[n++]=m;
                }
    if (a=='S'){
                Shape* m=new Square;
                m->Create();
                arr[n++]=m;
                }
}

void Shapes::printShape(int p)
{
    arr[p-1]->print();
}

void Shapes::calculateAllArea()
{
    float c=0;
    for(int i=0;i<n;i++) c+=arr[i]->Area();
    cout<<"AlArea: "<<c<<endl;
}
int main()
{
    
 return 0;
}
