#include <iostream>
using namespace std;

class Operations {
	public:
	//	virtual Operations& Sum(const Operations& ob) = 0;
		virtual double Multiply(int n) = 0; //triabva da vrushta Operations
		virtual int value(int n) = 0;
		virtual int Size() = 0; 
		virtual void print() = 0;
};


class Vector: public Operations {
	int* arr;
	int size;
	public:
	Vector(): arr(NULL), size(0) {}
	Vector(const Vector& v) {
		size = v.size;
		arr = new int[size];
		for(int i =0 ;i<size;i++) arr[i] = v.arr[i];
	}
	Vector& operator=(const Vector& v) {
		if(this!=&v) {
			delete arr;
			size = v.size;
			arr = new int[size];
			for(int i=0;i<size;i++) arr[i] = v.arr[i];
		}
		return *this;
	}
	~Vector() { delete arr; }

	int value(int n) {
		if(n>size) return -1;
		else return arr[n];
	}

	int Size() { return size; }
	void print() { for(int i=0;i<size;i++) cout << arr[i]; }
	

};

class Polynome: public Operations {
	int* arr;
	int size;
	public:
	Polynome(): arr(NULL), size(0) {}
	Polynome(const Polynome& p) {
		size = p.size;
		arr = new int[size];
		for(int i=0;i<size;i++) arr[i] = p.arr[i];
	} 
	Polynome& operator=(const Polynome& p) {
		if(this!=&p) {
			delete arr;
			size = p.size;
			arr = new int[size];
			for(int i=0; i<size; i++) arr[i] = p.arr[i];
		}
		return *this;
	}
	~Polynome() { delete arr; }

	int value(int n) {
		int returnValue = 0;
		for(int i=0; i<size;i++) {
			returnValue += arr[i]*(size-i);
		}
		return returnValue;
	}

	int Size() { return size; };
	void print() { for(int i=0;i<size;i++) cout << arr[i]; }

	
};
	
				
int count(Operations* arr[], int len, int val, int dim) {
	int returnValue = 0;
	for(int i=0;i<len;i++)
		if(arr[i]->Size() == dim) returnValue+=arr[i]->value(val);
	return returnValue;
}


int main()  {


} 
