// kontr2.cpp : Defines the entry point for the console application.
//Stela Dimitrova Todorova, 44657, 2 kurs, 1 potok, 1 grupa

#include "stdafx.h"
#include <iostream>
using namespace std;
int const SIZE = 50;

class Operations
{
  public:
  virtual Operations& sum(Operations&,Operations&) = 0;  
  virtual Operations& mult(Operations&,int) = 0;
  virtual double stoinost(Operations&,int) = 0;
  virtual int dim() = 0;
  virtual void print() const = 0;
 
};

class Vector : public Operations
{
 private:
	 double* vec;
 public:
	 int broi(Operations&);
 virtual Operations& sum(Operations&,Operations&);  
 virtual Operations& mult(Operations&,int);
 virtual double stoinost(int);
 virtual double dim();
 virtual void print() const;
};

int Vector::broi(Operations&)
{
  int i = 0;
	  while(a[i])
	  {
		  i++;
	  }
	  return i;
  
}
Vector& Vector::sum(Operations& a,Operations& b)
{
	  Vector nvec = new Vector[broi(a)+1];
	  if(broi(a) == broi(b))
	  {
      for(int i= 0; i<broi(a);i++)
	     {
			 nvec.vec[i] = a[i] + b[i]; 

	     }
	  }
   return  *nvec;
}

Vector& Vector::mult(Operations& a,int  t)
{
	  Vector nvec = new Vector[broi(a)+1];
	  
      for(int i= 0; i<broi(a);i++)
	     {
			 nvec.vec[i] = a[i]*t; 

	     }
	  
   return  *vec;
}
double Vector::stoinost(int  t)
{
	  
   return  vec[t];
}

int Vector::dim(Operations& a)
{
	 int i = 0;
	  while(a[i])
	  {
		  i++;
	  }
	  return i;
}

void Vector::print() const
{
     for(int i= 0; i<broi(a);i++)
	     {
          cout<<vec[i]<<endl; 

	     }
}

class Polynome : public Operations
{
 private:
	 double* koef;
	 int step;  //stepen
 public:
	int broi(Polynome&);
 virtual Operations& sum(Operations&,Operations&);  
 virtual Operations& mult(Operations&,int);
 virtual double stoinost(Operations&,int);
 virtual double dim();
 virtual void print() const;
};

int Vector::broi(Polynome& a)
{
  
	return a.step;
  
}
Polynome& Polynome::sum(Operations& a,Operations& b)
{
	  Polynome vec = new Polynome[broi(a)+1];
	 
	  
      for(int i= 0; i<broi(a);i++)
	     {
         vec[i] = a[i] + b[i]; 

	     }
	  
   return  *vec;
}

Polynome& Polynome::mult(Operations& a,int  t)
{
	  Polynome vec = new Polynome[broi(a)+1];
	  
      for(int i= 0; i<broi(a);i++)
	     {
         vec[i] = a[i]*t; 

	     }
	  
   return  *vec;
}
double Polynome::stoinost(int  t)
{
	  double res = 0;
      for(int i= 0; i<broi(a);i++)
	     {
			 res+=pow(t,step)*koef[i]; 

	     }
   return  res;
}

int Polynome::dim(Operations& a)
{
	 int i = 0;
	  while(a[i])
	  {
		  i++;
	  }
	  return i;
}

void Polynome::print() const
{
     for(int i= 0; i<broi(a);i++)
	     {

          cout<<vec[i]<<step<<endl; 

	     }
}
int func(Operations& a, double val, int dim)
{   int res = 0;
    for(int i= 0; i<broi(a);i++)
  	if(dim(a[i])==dim && stoinost(a[i].stoinost)==val)
		res+=a[i];
    return res;

}
int main()
{
	return 0;
}

